# Getting Started

> Note: this guide is currently in the process of being written (E#79531)

This guide will introduce you to the VPUX Compiler. By the end of this guide, you will have an overview of how the compiler works, a working setup, as well as the necessary tools to start testing, debugging and contributing to the project.

1. **[Introduction](introduction.md)**: An overview of the project
2. **[How to build](../../../guides/how-to-build.md)**: Instructions on building the project from source locally
3. **[MLIR Primer tutorial](guides/primer_mlir.md)**: Introduction to the basic concepts of MLIR, which is the framework that the compiler is built upon
4. **[VPU Primer tutorial](guides/primer_vpu.md)**: Introduction to the VPU and how it ties together with the compiler
5. **[How to debug](guides/how_to_debug.md)**: Information and tools on debugging
6. **[How to test](../../../guides/how-to-test.md)**: Information about the testing infrastructure of the project
7. **[How to run inferences](guides/how_to_run_inferences.md)**: Information on running inferences using the models compiled with the project
8. **[How to contribute](guides/how_to_contribute.md)**: Helpful information for contributing to the project
