# 1.Brief
This pass is aim to convert an interpolate ot concat and convolution. There have two convert versions. Only when scaleW = scaleH = 2 and the C dimension is 32 aligned, the V2 version conversion is used. In other cases, the V1 version conversion is used.
# 2.Flow-process diagram of V1
```
  -----
  |1|2|
  -----
  |3|4|
  -----
    |
    V
  concat
    |
    V
  ---------
  |1|1|2|2|
  ---------
  |1|1|2|2|
  ---------
  |3|3|4|4|
  ---------
  |3|3|4|4|
  ---------
      |
      V
    slice
      |
      V
  -----------
  |1|1|2|2|2|
  -----------
  |1|1|2|2|2|
  -----------
  |3|3|4|4|4|
  -----------
  |3|3|4|4|4|
  -----------
  |3|3|4|4|4|
  -----------
       |
       V
    2x2AvgConv
       |
       V
  -----------
  |1|1.5|2|2|
  -----------
  |1|2.5|3|3|
  -----------
  |3|3.5|4|4|
  -----------
  |3|3.5|4|4|
  -----------
  ```

# 3.Flow-process diagram of V2
```
                  -------
                  |1 |7 |
                  -------
                  |13|19|
                  -------
                    |
                    V
                  concat
        ------------+-------------------------------
        |           |                |             |
        V           V                V             V
    -------     ----------      ----------      -------
    |1 |7 |     |1 |7 |7 |      |1 |7 |7 |      |1 |7 |
    -------     ----------      ----------      -------
    |13|19|     |13|19|19|      |13|19|19|      |13|19|
    -------     ----------      ----------      -------
       |        |13|19|19|           |          |13|19|
       |        ----------           |          -------
       |             |               |             |
       |             V               V             V
       |         2x2AvgConv      2x1AvgConv     1x2AvgConv
       |             |               |             |
       V             V               V             V
  -----------  -----------      -----------   -----------
  |1 | |7 | |  | |  | |  |      | |4 | |7 |   |  | |  | |
  -----------  -----------      -----------   -----------
  |  | |  | |  | |10| |13|      | |  | |  |   |7 | |13| |
  -----------  -----------      -----------   -----------
  |13| |19| |  | |  | |  |      | |16| |19|   |  | |  | |
  -----------  -----------      -----------   -----------
  |  | |  | |  | |16| |19|      | |  | |  |   |13| |19| |
  -----------  -----------      -----------   -----------
       |           |                |             |
       ------------+-------------------------------
                   |
                   V
             -------------
             |1 |4 |7 |7 |
             -------------
             |7 |10|13|13|
             -------------
             |13|16|19|19|
             -------------
             |13|16|19|19|
             -------------
```

